#include "stdafx.h"
#include "MyFileSys.h"

MyFileSys::MyFileSys(FileSysType type)
: FileSys(),
	m_fileSys(FileSys::Create(type)),
	m_writing(false)
{
}

MyFileSys::~MyFileSys()
{
	delete m_fileSys;
}

void MyFileSys::Set(StrPtr const & name)
{
	FileSys::Set(name);
	m_fileSys->Set(name);
}

int MyFileSys::DoIndirectWrites()
{
	return m_fileSys->DoIndirectWrites();
}

void MyFileSys::Translator(CharSetCvt * const arg)
{
	FileSys::Translator(arg);
	m_fileSys->Translator(arg);
}

void MyFileSys::Open(FileOpenMode const mode, Error * const e)
{
	if (mode == FOM_WRITE)
	{
		m_writing = true;
		return;
	}

	m_fileSys->Open(mode, e);
}

void MyFileSys::Write(char const * const buf, int const len, Error * const e)
{
}

int MyFileSys::Read(char * const buf, int const len, Error * const e)
{
	return m_fileSys->Read(buf, len, e);
}

void MyFileSys::Close(Error * const e)
{
	if (m_writing)
	{
		m_writing = false;
		return;
	}

	m_fileSys->Close(e);
}

int MyFileSys::Stat()
{
	return m_fileSys->Stat();
}

int MyFileSys::StatModTime()
{
	return m_fileSys->StatModTime();
}

void MyFileSys::Truncate(Error *)
{
}

void MyFileSys::Unlink(Error *)
{
}

void MyFileSys::Rename(FileSys *, Error *)
{
}

void MyFileSys::Chmod(FilePerm const perms, Error * const e)
{
	m_fileSys->Chmod(perms, e);
}

void MyFileSys::ChmodTime(Error * const e)
{
	m_fileSys->ChmodTime(e);
}

int MyFileSys::GetFd()
{
	return m_fileSys->GetFd();
}

size_t MyFileSys::GetSize()
{
	return m_fileSys->GetSize();
}

void MyFileSys::Seek(off_t const offset)
{
	m_fileSys->Seek(offset);
}
