#ifndef INCLUDED_MyFileSys_H
#define INCLUDED_MyFileSys_H

class MyFileSys : public FileSys
{
public:

	MyFileSys(FileSysType type);
	virtual ~MyFileSys();

	virtual void Set(StrPtr const & name);
	virtual int DoIndirectWrites();
	virtual void Translator(CharSetCvt *);

	virtual void Open(FileOpenMode mode, Error * e);
	virtual void Write(char const * buf, int len, Error * e);
	virtual int Read(char * buf, int len, Error * e);
	virtual void Close(Error * e);

	virtual int Stat();
	virtual int StatModTime();
	virtual void Truncate(Error * e);
	virtual void Unlink(Error * e);
	virtual void Rename(FileSys * target, Error * e);
	virtual void Chmod(FilePerm perms, Error * e);
	virtual void ChmodTime(Error * e);

	virtual int GetFd();
	virtual size_t GetSize();
	virtual void Seek(off_t offset);

private:

	MyFileSys();
	MyFileSys(MyFileSys &);
	MyFileSys & operator =(MyFileSys &);

private:

	FileSys * m_fileSys;
	bool m_writing;
};

#endif
